// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/cloud/cloud_models"
)

// DeleteHubReader is a Reader for the DeleteHub structure.
type DeleteHubReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteHubReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteHubOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteHubUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteHubForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteHubNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteHubUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteHubInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewDeleteHubOK creates a DeleteHubOK with default headers values
func NewDeleteHubOK() *DeleteHubOK {
	return &DeleteHubOK{}
}

/* DeleteHubOK describes a response with status code 200, with default header values.

Taxnexus Response with Message Objects with Delete Status
*/
type DeleteHubOK struct {
	AccessControlAllowOrigin string

	Payload *cloud_models.DeleteResponse
}

func (o *DeleteHubOK) Error() string {
	return fmt.Sprintf("[DELETE /hubs][%d] deleteHubOK  %+v", 200, o.Payload)
}
func (o *DeleteHubOK) GetPayload() *cloud_models.DeleteResponse {
	return o.Payload
}

func (o *DeleteHubOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(cloud_models.DeleteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteHubUnauthorized creates a DeleteHubUnauthorized with default headers values
func NewDeleteHubUnauthorized() *DeleteHubUnauthorized {
	return &DeleteHubUnauthorized{}
}

/* DeleteHubUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type DeleteHubUnauthorized struct {
	Payload *cloud_models.Error
}

func (o *DeleteHubUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /hubs][%d] deleteHubUnauthorized  %+v", 401, o.Payload)
}
func (o *DeleteHubUnauthorized) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *DeleteHubUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteHubForbidden creates a DeleteHubForbidden with default headers values
func NewDeleteHubForbidden() *DeleteHubForbidden {
	return &DeleteHubForbidden{}
}

/* DeleteHubForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type DeleteHubForbidden struct {
	Payload *cloud_models.Error
}

func (o *DeleteHubForbidden) Error() string {
	return fmt.Sprintf("[DELETE /hubs][%d] deleteHubForbidden  %+v", 403, o.Payload)
}
func (o *DeleteHubForbidden) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *DeleteHubForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteHubNotFound creates a DeleteHubNotFound with default headers values
func NewDeleteHubNotFound() *DeleteHubNotFound {
	return &DeleteHubNotFound{}
}

/* DeleteHubNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type DeleteHubNotFound struct {
	Payload *cloud_models.Error
}

func (o *DeleteHubNotFound) Error() string {
	return fmt.Sprintf("[DELETE /hubs][%d] deleteHubNotFound  %+v", 404, o.Payload)
}
func (o *DeleteHubNotFound) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *DeleteHubNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteHubUnprocessableEntity creates a DeleteHubUnprocessableEntity with default headers values
func NewDeleteHubUnprocessableEntity() *DeleteHubUnprocessableEntity {
	return &DeleteHubUnprocessableEntity{}
}

/* DeleteHubUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type DeleteHubUnprocessableEntity struct {
	Payload *cloud_models.Error
}

func (o *DeleteHubUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /hubs][%d] deleteHubUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *DeleteHubUnprocessableEntity) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *DeleteHubUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteHubInternalServerError creates a DeleteHubInternalServerError with default headers values
func NewDeleteHubInternalServerError() *DeleteHubInternalServerError {
	return &DeleteHubInternalServerError{}
}

/* DeleteHubInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type DeleteHubInternalServerError struct {
	Payload *cloud_models.Error
}

func (o *DeleteHubInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /hubs][%d] deleteHubInternalServerError  %+v", 500, o.Payload)
}
func (o *DeleteHubInternalServerError) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *DeleteHubInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
