// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetHubsParams creates a new GetHubsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetHubsParams() *GetHubsParams {
	return &GetHubsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetHubsParamsWithTimeout creates a new GetHubsParams object
// with the ability to set a timeout on a request.
func NewGetHubsParamsWithTimeout(timeout time.Duration) *GetHubsParams {
	return &GetHubsParams{
		timeout: timeout,
	}
}

// NewGetHubsParamsWithContext creates a new GetHubsParams object
// with the ability to set a context for a request.
func NewGetHubsParamsWithContext(ctx context.Context) *GetHubsParams {
	return &GetHubsParams{
		Context: ctx,
	}
}

// NewGetHubsParamsWithHTTPClient creates a new GetHubsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetHubsParamsWithHTTPClient(client *http.Client) *GetHubsParams {
	return &GetHubsParams{
		HTTPClient: client,
	}
}

/* GetHubsParams contains all the parameters to send to the API endpoint
   for the get hubs operation.

   Typically these are written to a http.Request.
*/
type GetHubsParams struct {

	/* AccountID.

	   Taxnexus Record Id of an Account
	*/
	AccountID *string

	/* Active.

	   Retrieve active records?
	*/
	Active *bool

	/* Email.

	   Email address?
	*/
	Email *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Name.

	   The Name of this Object
	*/
	Name *string

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get hubs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetHubsParams) WithDefaults() *GetHubsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get hubs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetHubsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get hubs params
func (o *GetHubsParams) WithTimeout(timeout time.Duration) *GetHubsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get hubs params
func (o *GetHubsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get hubs params
func (o *GetHubsParams) WithContext(ctx context.Context) *GetHubsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get hubs params
func (o *GetHubsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get hubs params
func (o *GetHubsParams) WithHTTPClient(client *http.Client) *GetHubsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get hubs params
func (o *GetHubsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get hubs params
func (o *GetHubsParams) WithAccountID(accountID *string) *GetHubsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get hubs params
func (o *GetHubsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get hubs params
func (o *GetHubsParams) WithActive(active *bool) *GetHubsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get hubs params
func (o *GetHubsParams) SetActive(active *bool) {
	o.Active = active
}

// WithEmail adds the email to the get hubs params
func (o *GetHubsParams) WithEmail(email *string) *GetHubsParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the get hubs params
func (o *GetHubsParams) SetEmail(email *string) {
	o.Email = email
}

// WithLimit adds the limit to the get hubs params
func (o *GetHubsParams) WithLimit(limit *int64) *GetHubsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get hubs params
func (o *GetHubsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithName adds the name to the get hubs params
func (o *GetHubsParams) WithName(name *string) *GetHubsParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get hubs params
func (o *GetHubsParams) SetName(name *string) {
	o.Name = name
}

// WithOffset adds the offset to the get hubs params
func (o *GetHubsParams) WithOffset(offset *int64) *GetHubsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get hubs params
func (o *GetHubsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetHubsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string

		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {

			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}
	}

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.Email != nil {

		// query param email
		var qrEmail string

		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
