// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/cloud/cloud_models"
)

// GetHubsReader is a Reader for the GetHubs structure.
type GetHubsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetHubsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetHubsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetHubsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetHubsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetHubsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetHubsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetHubsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetHubsOK creates a GetHubsOK with default headers values
func NewGetHubsOK() *GetHubsOK {
	return &GetHubsOK{}
}

/* GetHubsOK describes a response with status code 200, with default header values.

Telnexus Response with Hub objects
*/
type GetHubsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *cloud_models.HubResponse
}

func (o *GetHubsOK) Error() string {
	return fmt.Sprintf("[GET /hubs][%d] getHubsOK  %+v", 200, o.Payload)
}
func (o *GetHubsOK) GetPayload() *cloud_models.HubResponse {
	return o.Payload
}

func (o *GetHubsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(cloud_models.HubResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHubsUnauthorized creates a GetHubsUnauthorized with default headers values
func NewGetHubsUnauthorized() *GetHubsUnauthorized {
	return &GetHubsUnauthorized{}
}

/* GetHubsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetHubsUnauthorized struct {
	Payload *cloud_models.Error
}

func (o *GetHubsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /hubs][%d] getHubsUnauthorized  %+v", 401, o.Payload)
}
func (o *GetHubsUnauthorized) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *GetHubsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHubsForbidden creates a GetHubsForbidden with default headers values
func NewGetHubsForbidden() *GetHubsForbidden {
	return &GetHubsForbidden{}
}

/* GetHubsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetHubsForbidden struct {
	Payload *cloud_models.Error
}

func (o *GetHubsForbidden) Error() string {
	return fmt.Sprintf("[GET /hubs][%d] getHubsForbidden  %+v", 403, o.Payload)
}
func (o *GetHubsForbidden) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *GetHubsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHubsNotFound creates a GetHubsNotFound with default headers values
func NewGetHubsNotFound() *GetHubsNotFound {
	return &GetHubsNotFound{}
}

/* GetHubsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetHubsNotFound struct {
	Payload *cloud_models.Error
}

func (o *GetHubsNotFound) Error() string {
	return fmt.Sprintf("[GET /hubs][%d] getHubsNotFound  %+v", 404, o.Payload)
}
func (o *GetHubsNotFound) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *GetHubsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHubsUnprocessableEntity creates a GetHubsUnprocessableEntity with default headers values
func NewGetHubsUnprocessableEntity() *GetHubsUnprocessableEntity {
	return &GetHubsUnprocessableEntity{}
}

/* GetHubsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetHubsUnprocessableEntity struct {
	Payload *cloud_models.Error
}

func (o *GetHubsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /hubs][%d] getHubsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetHubsUnprocessableEntity) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *GetHubsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHubsInternalServerError creates a GetHubsInternalServerError with default headers values
func NewGetHubsInternalServerError() *GetHubsInternalServerError {
	return &GetHubsInternalServerError{}
}

/* GetHubsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetHubsInternalServerError struct {
	Payload *cloud_models.Error
}

func (o *GetHubsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /hubs][%d] getHubsInternalServerError  %+v", 500, o.Payload)
}
func (o *GetHubsInternalServerError) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *GetHubsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
