// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new hub API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for hub API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteHub(params *DeleteHubParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteHubOK, error)

	GetHubs(params *GetHubsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetHubsOK, error)

	PostHubs(params *PostHubsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostHubsOK, error)

	PutHub(params *PutHubParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutHubOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeleteHub deletes an hub

  Delete Telnexus Hub record
*/
func (a *Client) DeleteHub(params *DeleteHubParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteHubOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteHubParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteHub",
		Method:             "DELETE",
		PathPattern:        "/hubs",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteHubReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteHubOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteHub: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetHubs gets a list of accounts

  Return a list of all available Hubs
*/
func (a *Client) GetHubs(params *GetHubsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetHubsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetHubsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getHubs",
		Method:             "GET",
		PathPattern:        "/hubs",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetHubsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetHubsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getHubs: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostHubs adds a new account to telnexus

  Hub record to be added
*/
func (a *Client) PostHubs(params *PostHubsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostHubsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostHubsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postHubs",
		Method:             "POST",
		PathPattern:        "/hubs",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostHubsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostHubsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postHubs: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutHub updates a single account

  Update Hubs
*/
func (a *Client) PutHub(params *PutHubParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutHubOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutHubParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putHub",
		Method:             "PUT",
		PathPattern:        "/hubs",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutHubReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutHubOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putHub: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
