// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/cloud/cloud_models"
)

// NewPostHubsParams creates a new PostHubsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostHubsParams() *PostHubsParams {
	return &PostHubsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostHubsParamsWithTimeout creates a new PostHubsParams object
// with the ability to set a timeout on a request.
func NewPostHubsParamsWithTimeout(timeout time.Duration) *PostHubsParams {
	return &PostHubsParams{
		timeout: timeout,
	}
}

// NewPostHubsParamsWithContext creates a new PostHubsParams object
// with the ability to set a context for a request.
func NewPostHubsParamsWithContext(ctx context.Context) *PostHubsParams {
	return &PostHubsParams{
		Context: ctx,
	}
}

// NewPostHubsParamsWithHTTPClient creates a new PostHubsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostHubsParamsWithHTTPClient(client *http.Client) *PostHubsParams {
	return &PostHubsParams{
		HTTPClient: client,
	}
}

/* PostHubsParams contains all the parameters to send to the API endpoint
   for the post hubs operation.

   Typically these are written to a http.Request.
*/
type PostHubsParams struct {

	/* HubRequest.

	   An array of new Hub records
	*/
	HubRequest *cloud_models.HubRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post hubs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostHubsParams) WithDefaults() *PostHubsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post hubs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostHubsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post hubs params
func (o *PostHubsParams) WithTimeout(timeout time.Duration) *PostHubsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post hubs params
func (o *PostHubsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post hubs params
func (o *PostHubsParams) WithContext(ctx context.Context) *PostHubsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post hubs params
func (o *PostHubsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post hubs params
func (o *PostHubsParams) WithHTTPClient(client *http.Client) *PostHubsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post hubs params
func (o *PostHubsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithHubRequest adds the hubRequest to the post hubs params
func (o *PostHubsParams) WithHubRequest(hubRequest *cloud_models.HubRequest) *PostHubsParams {
	o.SetHubRequest(hubRequest)
	return o
}

// SetHubRequest adds the hubRequest to the post hubs params
func (o *PostHubsParams) SetHubRequest(hubRequest *cloud_models.HubRequest) {
	o.HubRequest = hubRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostHubsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.HubRequest != nil {
		if err := r.SetBodyParam(o.HubRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
