// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/cloud/cloud_models"
)

// NewPutHubParams creates a new PutHubParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutHubParams() *PutHubParams {
	return &PutHubParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutHubParamsWithTimeout creates a new PutHubParams object
// with the ability to set a timeout on a request.
func NewPutHubParamsWithTimeout(timeout time.Duration) *PutHubParams {
	return &PutHubParams{
		timeout: timeout,
	}
}

// NewPutHubParamsWithContext creates a new PutHubParams object
// with the ability to set a context for a request.
func NewPutHubParamsWithContext(ctx context.Context) *PutHubParams {
	return &PutHubParams{
		Context: ctx,
	}
}

// NewPutHubParamsWithHTTPClient creates a new PutHubParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutHubParamsWithHTTPClient(client *http.Client) *PutHubParams {
	return &PutHubParams{
		HTTPClient: client,
	}
}

/* PutHubParams contains all the parameters to send to the API endpoint
   for the put hub operation.

   Typically these are written to a http.Request.
*/
type PutHubParams struct {

	/* HubRequest.

	   An array of new Hub records
	*/
	HubRequest *cloud_models.HubRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put hub params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutHubParams) WithDefaults() *PutHubParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put hub params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutHubParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put hub params
func (o *PutHubParams) WithTimeout(timeout time.Duration) *PutHubParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put hub params
func (o *PutHubParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put hub params
func (o *PutHubParams) WithContext(ctx context.Context) *PutHubParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put hub params
func (o *PutHubParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put hub params
func (o *PutHubParams) WithHTTPClient(client *http.Client) *PutHubParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put hub params
func (o *PutHubParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithHubRequest adds the hubRequest to the put hub params
func (o *PutHubParams) WithHubRequest(hubRequest *cloud_models.HubRequest) *PutHubParams {
	o.SetHubRequest(hubRequest)
	return o
}

// SetHubRequest adds the hubRequest to the put hub params
func (o *PutHubParams) SetHubRequest(hubRequest *cloud_models.HubRequest) {
	o.HubRequest = hubRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutHubParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.HubRequest != nil {
		if err := r.SetBodyParam(o.HubRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
