// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/cloud/cloud_models"
)

// PutHubReader is a Reader for the PutHub structure.
type PutHubReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutHubReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutHubOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutHubUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutHubForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutHubNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutHubUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutHubInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutHubOK creates a PutHubOK with default headers values
func NewPutHubOK() *PutHubOK {
	return &PutHubOK{}
}

/* PutHubOK describes a response with status code 200, with default header values.

Telnexus Response with Hub objects
*/
type PutHubOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *cloud_models.HubResponse
}

func (o *PutHubOK) Error() string {
	return fmt.Sprintf("[PUT /hubs][%d] putHubOK  %+v", 200, o.Payload)
}
func (o *PutHubOK) GetPayload() *cloud_models.HubResponse {
	return o.Payload
}

func (o *PutHubOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(cloud_models.HubResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutHubUnauthorized creates a PutHubUnauthorized with default headers values
func NewPutHubUnauthorized() *PutHubUnauthorized {
	return &PutHubUnauthorized{}
}

/* PutHubUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutHubUnauthorized struct {
	Payload *cloud_models.Error
}

func (o *PutHubUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /hubs][%d] putHubUnauthorized  %+v", 401, o.Payload)
}
func (o *PutHubUnauthorized) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PutHubUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutHubForbidden creates a PutHubForbidden with default headers values
func NewPutHubForbidden() *PutHubForbidden {
	return &PutHubForbidden{}
}

/* PutHubForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutHubForbidden struct {
	Payload *cloud_models.Error
}

func (o *PutHubForbidden) Error() string {
	return fmt.Sprintf("[PUT /hubs][%d] putHubForbidden  %+v", 403, o.Payload)
}
func (o *PutHubForbidden) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PutHubForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutHubNotFound creates a PutHubNotFound with default headers values
func NewPutHubNotFound() *PutHubNotFound {
	return &PutHubNotFound{}
}

/* PutHubNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutHubNotFound struct {
	Payload *cloud_models.Error
}

func (o *PutHubNotFound) Error() string {
	return fmt.Sprintf("[PUT /hubs][%d] putHubNotFound  %+v", 404, o.Payload)
}
func (o *PutHubNotFound) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PutHubNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutHubUnprocessableEntity creates a PutHubUnprocessableEntity with default headers values
func NewPutHubUnprocessableEntity() *PutHubUnprocessableEntity {
	return &PutHubUnprocessableEntity{}
}

/* PutHubUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutHubUnprocessableEntity struct {
	Payload *cloud_models.Error
}

func (o *PutHubUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /hubs][%d] putHubUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutHubUnprocessableEntity) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PutHubUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutHubInternalServerError creates a PutHubInternalServerError with default headers values
func NewPutHubInternalServerError() *PutHubInternalServerError {
	return &PutHubInternalServerError{}
}

/* PutHubInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutHubInternalServerError struct {
	Payload *cloud_models.Error
}

func (o *PutHubInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /hubs][%d] putHubInternalServerError  %+v", 500, o.Payload)
}
func (o *PutHubInternalServerError) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PutHubInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
