// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetContactsObservableParams creates a new GetContactsObservableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetContactsObservableParams() *GetContactsObservableParams {
	return &GetContactsObservableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetContactsObservableParamsWithTimeout creates a new GetContactsObservableParams object
// with the ability to set a timeout on a request.
func NewGetContactsObservableParamsWithTimeout(timeout time.Duration) *GetContactsObservableParams {
	return &GetContactsObservableParams{
		timeout: timeout,
	}
}

// NewGetContactsObservableParamsWithContext creates a new GetContactsObservableParams object
// with the ability to set a context for a request.
func NewGetContactsObservableParamsWithContext(ctx context.Context) *GetContactsObservableParams {
	return &GetContactsObservableParams{
		Context: ctx,
	}
}

// NewGetContactsObservableParamsWithHTTPClient creates a new GetContactsObservableParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetContactsObservableParamsWithHTTPClient(client *http.Client) *GetContactsObservableParams {
	return &GetContactsObservableParams{
		HTTPClient: client,
	}
}

/* GetContactsObservableParams contains all the parameters to send to the API endpoint
   for the get contacts observable operation.

   Typically these are written to a http.Request.
*/
type GetContactsObservableParams struct {

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* ContactID.

	   Telnexus Contact record ID
	*/
	ContactID *string

	/* Email.

	   Email address used for identity lookup
	*/
	Email *string

	/* Name.

	   The Name of this Object
	*/
	Name *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get contacts observable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetContactsObservableParams) WithDefaults() *GetContactsObservableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get contacts observable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetContactsObservableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get contacts observable params
func (o *GetContactsObservableParams) WithTimeout(timeout time.Duration) *GetContactsObservableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get contacts observable params
func (o *GetContactsObservableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get contacts observable params
func (o *GetContactsObservableParams) WithContext(ctx context.Context) *GetContactsObservableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get contacts observable params
func (o *GetContactsObservableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get contacts observable params
func (o *GetContactsObservableParams) WithHTTPClient(client *http.Client) *GetContactsObservableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get contacts observable params
func (o *GetContactsObservableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get contacts observable params
func (o *GetContactsObservableParams) WithActive(active *bool) *GetContactsObservableParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get contacts observable params
func (o *GetContactsObservableParams) SetActive(active *bool) {
	o.Active = active
}

// WithContactID adds the contactID to the get contacts observable params
func (o *GetContactsObservableParams) WithContactID(contactID *string) *GetContactsObservableParams {
	o.SetContactID(contactID)
	return o
}

// SetContactID adds the contactId to the get contacts observable params
func (o *GetContactsObservableParams) SetContactID(contactID *string) {
	o.ContactID = contactID
}

// WithEmail adds the email to the get contacts observable params
func (o *GetContactsObservableParams) WithEmail(email *string) *GetContactsObservableParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the get contacts observable params
func (o *GetContactsObservableParams) SetEmail(email *string) {
	o.Email = email
}

// WithName adds the name to the get contacts observable params
func (o *GetContactsObservableParams) WithName(name *string) *GetContactsObservableParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get contacts observable params
func (o *GetContactsObservableParams) SetName(name *string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *GetContactsObservableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.ContactID != nil {

		// query param contactId
		var qrContactID string

		if o.ContactID != nil {
			qrContactID = *o.ContactID
		}
		qContactID := qrContactID
		if qContactID != "" {

			if err := r.SetQueryParam("contactId", qContactID); err != nil {
				return err
			}
		}
	}

	if o.Email != nil {

		// query param email
		var qrEmail string

		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
