// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// NewPostContactsParams creates a new PostContactsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostContactsParams() *PostContactsParams {
	return &PostContactsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostContactsParamsWithTimeout creates a new PostContactsParams object
// with the ability to set a timeout on a request.
func NewPostContactsParamsWithTimeout(timeout time.Duration) *PostContactsParams {
	return &PostContactsParams{
		timeout: timeout,
	}
}

// NewPostContactsParamsWithContext creates a new PostContactsParams object
// with the ability to set a context for a request.
func NewPostContactsParamsWithContext(ctx context.Context) *PostContactsParams {
	return &PostContactsParams{
		Context: ctx,
	}
}

// NewPostContactsParamsWithHTTPClient creates a new PostContactsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostContactsParamsWithHTTPClient(client *http.Client) *PostContactsParams {
	return &PostContactsParams{
		HTTPClient: client,
	}
}

/* PostContactsParams contains all the parameters to send to the API endpoint
   for the post contacts operation.

   Typically these are written to a http.Request.
*/
type PostContactsParams struct {

	/* ContactsRequest.

	   An array of new Contact records
	*/
	ContactsRequest *crm_models.ContactRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post contacts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostContactsParams) WithDefaults() *PostContactsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post contacts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostContactsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post contacts params
func (o *PostContactsParams) WithTimeout(timeout time.Duration) *PostContactsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post contacts params
func (o *PostContactsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post contacts params
func (o *PostContactsParams) WithContext(ctx context.Context) *PostContactsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post contacts params
func (o *PostContactsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post contacts params
func (o *PostContactsParams) WithHTTPClient(client *http.Client) *PostContactsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post contacts params
func (o *PostContactsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContactsRequest adds the contactsRequest to the post contacts params
func (o *PostContactsParams) WithContactsRequest(contactsRequest *crm_models.ContactRequest) *PostContactsParams {
	o.SetContactsRequest(contactsRequest)
	return o
}

// SetContactsRequest adds the contactsRequest to the post contacts params
func (o *PostContactsParams) SetContactsRequest(contactsRequest *crm_models.ContactRequest) {
	o.ContactsRequest = contactsRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostContactsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.ContactsRequest != nil {
		if err := r.SetBodyParam(o.ContactsRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
