// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// GetLeadsReader is a Reader for the GetLeads structure.
type GetLeadsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLeadsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetLeadsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetLeadsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetLeadsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetLeadsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetLeadsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetLeadsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetLeadsOK creates a GetLeadsOK with default headers values
func NewGetLeadsOK() *GetLeadsOK {
	return &GetLeadsOK{}
}

/* GetLeadsOK describes a response with status code 200, with default header values.

Telnexus Response with an array of Lead objects
*/
type GetLeadsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.LeadResponse
}

func (o *GetLeadsOK) Error() string {
	return fmt.Sprintf("[GET /leads][%d] getLeadsOK  %+v", 200, o.Payload)
}
func (o *GetLeadsOK) GetPayload() *crm_models.LeadResponse {
	return o.Payload
}

func (o *GetLeadsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.LeadResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsUnauthorized creates a GetLeadsUnauthorized with default headers values
func NewGetLeadsUnauthorized() *GetLeadsUnauthorized {
	return &GetLeadsUnauthorized{}
}

/* GetLeadsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetLeadsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /leads][%d] getLeadsUnauthorized  %+v", 401, o.Payload)
}
func (o *GetLeadsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsForbidden creates a GetLeadsForbidden with default headers values
func NewGetLeadsForbidden() *GetLeadsForbidden {
	return &GetLeadsForbidden{}
}

/* GetLeadsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetLeadsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsForbidden) Error() string {
	return fmt.Sprintf("[GET /leads][%d] getLeadsForbidden  %+v", 403, o.Payload)
}
func (o *GetLeadsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsNotFound creates a GetLeadsNotFound with default headers values
func NewGetLeadsNotFound() *GetLeadsNotFound {
	return &GetLeadsNotFound{}
}

/* GetLeadsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetLeadsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsNotFound) Error() string {
	return fmt.Sprintf("[GET /leads][%d] getLeadsNotFound  %+v", 404, o.Payload)
}
func (o *GetLeadsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsUnprocessableEntity creates a GetLeadsUnprocessableEntity with default headers values
func NewGetLeadsUnprocessableEntity() *GetLeadsUnprocessableEntity {
	return &GetLeadsUnprocessableEntity{}
}

/* GetLeadsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetLeadsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /leads][%d] getLeadsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetLeadsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsInternalServerError creates a GetLeadsInternalServerError with default headers values
func NewGetLeadsInternalServerError() *GetLeadsInternalServerError {
	return &GetLeadsInternalServerError{}
}

/* GetLeadsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetLeadsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /leads][%d] getLeadsInternalServerError  %+v", 500, o.Payload)
}
func (o *GetLeadsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
