// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// NewPutClustersParams creates a new PutClustersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutClustersParams() *PutClustersParams {
	return &PutClustersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutClustersParamsWithTimeout creates a new PutClustersParams object
// with the ability to set a timeout on a request.
func NewPutClustersParamsWithTimeout(timeout time.Duration) *PutClustersParams {
	return &PutClustersParams{
		timeout: timeout,
	}
}

// NewPutClustersParamsWithContext creates a new PutClustersParams object
// with the ability to set a context for a request.
func NewPutClustersParamsWithContext(ctx context.Context) *PutClustersParams {
	return &PutClustersParams{
		Context: ctx,
	}
}

// NewPutClustersParamsWithHTTPClient creates a new PutClustersParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutClustersParamsWithHTTPClient(client *http.Client) *PutClustersParams {
	return &PutClustersParams{
		HTTPClient: client,
	}
}

/* PutClustersParams contains all the parameters to send to the API endpoint
   for the put clusters operation.

   Typically these are written to a http.Request.
*/
type PutClustersParams struct {

	/* ClusterRequest.

	   An array of Cluster records
	*/
	ClusterRequest *devops_models.ClusterRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put clusters params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutClustersParams) WithDefaults() *PutClustersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put clusters params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutClustersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put clusters params
func (o *PutClustersParams) WithTimeout(timeout time.Duration) *PutClustersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put clusters params
func (o *PutClustersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put clusters params
func (o *PutClustersParams) WithContext(ctx context.Context) *PutClustersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put clusters params
func (o *PutClustersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put clusters params
func (o *PutClustersParams) WithHTTPClient(client *http.Client) *PutClustersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put clusters params
func (o *PutClustersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClusterRequest adds the clusterRequest to the put clusters params
func (o *PutClustersParams) WithClusterRequest(clusterRequest *devops_models.ClusterRequest) *PutClustersParams {
	o.SetClusterRequest(clusterRequest)
	return o
}

// SetClusterRequest adds the clusterRequest to the put clusters params
func (o *PutClustersParams) SetClusterRequest(clusterRequest *devops_models.ClusterRequest) {
	o.ClusterRequest = clusterRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutClustersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.ClusterRequest != nil {
		if err := r.SetBodyParam(o.ClusterRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
