// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingest

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new ingest API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for ingest API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetIngest(params *GetIngestParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIngestOK, error)

	GetIngests(params *GetIngestsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIngestsOK, error)

	GetIngestsObservable(params *GetIngestsObservableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIngestsObservableOK, error)

	PostIngests(params *PostIngestsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIngestsOK, error)

	PutIngests(params *PutIngestsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutIngestsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetIngest gets a single ingest object

  Return a single Ingest object from datastore as a Singleton
*/
func (a *Client) GetIngest(params *GetIngestParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIngestOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIngestParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIngest",
		Method:             "GET",
		PathPattern:        "/ingests/{ingestIdPath}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIngestReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIngestOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIngest: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetIngests gets a list ingests

  Return a list of Ingest records
*/
func (a *Client) GetIngests(params *GetIngestsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIngestsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIngestsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIngests",
		Method:             "GET",
		PathPattern:        "/ingests",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIngestsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIngestsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIngests: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetIngestsObservable gets ingests in an observable array

  Returns a Ingest retrieval in a observable array
*/
func (a *Client) GetIngestsObservable(params *GetIngestsObservableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIngestsObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIngestsObservableParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIngestsObservable",
		Method:             "GET",
		PathPattern:        "/ingests/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIngestsObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIngestsObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIngestsObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostIngests creates new ingests

  Create new Ingests
*/
func (a *Client) PostIngests(params *PostIngestsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIngestsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostIngestsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postIngests",
		Method:             "POST",
		PathPattern:        "/ingests",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostIngestsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostIngestsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postIngests: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutIngests updates ingests

  Update Ingests
*/
func (a *Client) PutIngests(params *PutIngestsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutIngestsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutIngestsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putIngests",
		Method:             "PUT",
		PathPattern:        "/ingests",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutIngestsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutIngestsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putIngests: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
