// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingest

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// PutIngestsReader is a Reader for the PutIngests structure.
type PutIngestsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutIngestsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutIngestsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutIngestsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutIngestsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutIngestsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutIngestsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutIngestsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutIngestsOK creates a PutIngestsOK with default headers values
func NewPutIngestsOK() *PutIngestsOK {
	return &PutIngestsOK{}
}

/* PutIngestsOK describes a response with status code 200, with default header values.

Telnexus Response with Ingest objects
*/
type PutIngestsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.IngestResponse
}

func (o *PutIngestsOK) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsOK  %+v", 200, o.Payload)
}
func (o *PutIngestsOK) GetPayload() *devops_models.IngestResponse {
	return o.Payload
}

func (o *PutIngestsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.IngestResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsUnauthorized creates a PutIngestsUnauthorized with default headers values
func NewPutIngestsUnauthorized() *PutIngestsUnauthorized {
	return &PutIngestsUnauthorized{}
}

/* PutIngestsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutIngestsUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PutIngestsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsUnauthorized  %+v", 401, o.Payload)
}
func (o *PutIngestsUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutIngestsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsForbidden creates a PutIngestsForbidden with default headers values
func NewPutIngestsForbidden() *PutIngestsForbidden {
	return &PutIngestsForbidden{}
}

/* PutIngestsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutIngestsForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutIngestsForbidden) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsForbidden  %+v", 403, o.Payload)
}
func (o *PutIngestsForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutIngestsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsNotFound creates a PutIngestsNotFound with default headers values
func NewPutIngestsNotFound() *PutIngestsNotFound {
	return &PutIngestsNotFound{}
}

/* PutIngestsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutIngestsNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutIngestsNotFound) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsNotFound  %+v", 404, o.Payload)
}
func (o *PutIngestsNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutIngestsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsUnprocessableEntity creates a PutIngestsUnprocessableEntity with default headers values
func NewPutIngestsUnprocessableEntity() *PutIngestsUnprocessableEntity {
	return &PutIngestsUnprocessableEntity{}
}

/* PutIngestsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutIngestsUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PutIngestsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutIngestsUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutIngestsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsInternalServerError creates a PutIngestsInternalServerError with default headers values
func NewPutIngestsInternalServerError() *PutIngestsInternalServerError {
	return &PutIngestsInternalServerError{}
}

/* PutIngestsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutIngestsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutIngestsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsInternalServerError  %+v", 500, o.Payload)
}
func (o *PutIngestsInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutIngestsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
