// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package job

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// PutJobsReader is a Reader for the PutJobs structure.
type PutJobsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutJobsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutJobsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutJobsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutJobsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutJobsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutJobsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutJobsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutJobsOK creates a PutJobsOK with default headers values
func NewPutJobsOK() *PutJobsOK {
	return &PutJobsOK{}
}

/* PutJobsOK describes a response with status code 200, with default header values.

Telnexus Response with Job objects
*/
type PutJobsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.JobResponse
}

func (o *PutJobsOK) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsOK  %+v", 200, o.Payload)
}
func (o *PutJobsOK) GetPayload() *devops_models.JobResponse {
	return o.Payload
}

func (o *PutJobsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.JobResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsUnauthorized creates a PutJobsUnauthorized with default headers values
func NewPutJobsUnauthorized() *PutJobsUnauthorized {
	return &PutJobsUnauthorized{}
}

/* PutJobsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutJobsUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PutJobsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsUnauthorized  %+v", 401, o.Payload)
}
func (o *PutJobsUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutJobsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsForbidden creates a PutJobsForbidden with default headers values
func NewPutJobsForbidden() *PutJobsForbidden {
	return &PutJobsForbidden{}
}

/* PutJobsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutJobsForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutJobsForbidden) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsForbidden  %+v", 403, o.Payload)
}
func (o *PutJobsForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutJobsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsNotFound creates a PutJobsNotFound with default headers values
func NewPutJobsNotFound() *PutJobsNotFound {
	return &PutJobsNotFound{}
}

/* PutJobsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutJobsNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutJobsNotFound) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsNotFound  %+v", 404, o.Payload)
}
func (o *PutJobsNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutJobsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsUnprocessableEntity creates a PutJobsUnprocessableEntity with default headers values
func NewPutJobsUnprocessableEntity() *PutJobsUnprocessableEntity {
	return &PutJobsUnprocessableEntity{}
}

/* PutJobsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutJobsUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PutJobsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutJobsUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutJobsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsInternalServerError creates a PutJobsInternalServerError with default headers values
func NewPutJobsInternalServerError() *PutJobsInternalServerError {
	return &PutJobsInternalServerError{}
}

/* PutJobsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutJobsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutJobsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsInternalServerError  %+v", 500, o.Payload)
}
func (o *PutJobsInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutJobsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
