// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenant

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetTenantParams creates a new GetTenantParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetTenantParams() *GetTenantParams {
	return &GetTenantParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetTenantParamsWithTimeout creates a new GetTenantParams object
// with the ability to set a timeout on a request.
func NewGetTenantParamsWithTimeout(timeout time.Duration) *GetTenantParams {
	return &GetTenantParams{
		timeout: timeout,
	}
}

// NewGetTenantParamsWithContext creates a new GetTenantParams object
// with the ability to set a context for a request.
func NewGetTenantParamsWithContext(ctx context.Context) *GetTenantParams {
	return &GetTenantParams{
		Context: ctx,
	}
}

// NewGetTenantParamsWithHTTPClient creates a new GetTenantParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetTenantParamsWithHTTPClient(client *http.Client) *GetTenantParams {
	return &GetTenantParams{
		HTTPClient: client,
	}
}

/* GetTenantParams contains all the parameters to send to the API endpoint
   for the get tenant operation.

   Typically these are written to a http.Request.
*/
type GetTenantParams struct {

	/* TenantIDPath.

	   Telnexus Record Id of a Tenant
	*/
	TenantIDPath string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get tenant params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTenantParams) WithDefaults() *GetTenantParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get tenant params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTenantParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get tenant params
func (o *GetTenantParams) WithTimeout(timeout time.Duration) *GetTenantParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get tenant params
func (o *GetTenantParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get tenant params
func (o *GetTenantParams) WithContext(ctx context.Context) *GetTenantParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get tenant params
func (o *GetTenantParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get tenant params
func (o *GetTenantParams) WithHTTPClient(client *http.Client) *GetTenantParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get tenant params
func (o *GetTenantParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTenantIDPath adds the tenantIDPath to the get tenant params
func (o *GetTenantParams) WithTenantIDPath(tenantIDPath string) *GetTenantParams {
	o.SetTenantIDPath(tenantIDPath)
	return o
}

// SetTenantIDPath adds the tenantIdPath to the get tenant params
func (o *GetTenantParams) SetTenantIDPath(tenantIDPath string) {
	o.TenantIDPath = tenantIDPath
}

// WriteToRequest writes these params to a swagger request
func (o *GetTenantParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param tenantIdPath
	if err := r.SetPathParam("tenantIdPath", o.TenantIDPath); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
