// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package phone_number

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new phone number API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for phone number API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetAccountNumbers(params *GetAccountNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetAccountNumbersOK, error)

	GetKazooNumbers(params *GetKazooNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetKazooNumbersOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetAccountNumbers get account numbers API
*/
func (a *Client) GetAccountNumbers(params *GetAccountNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetAccountNumbersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetAccountNumbersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getAccountNumbers",
		Method:             "GET",
		PathPattern:        "/accounts/{accountId}/phone_numebers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetAccountNumbersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetAccountNumbersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getAccountNumbers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetKazooNumbers get kazoo numbers API
*/
func (a *Client) GetKazooNumbers(params *GetKazooNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetKazooNumbersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetKazooNumbersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getKazooNumbers",
		Method:             "GET",
		PathPattern:        "/phone_numebers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetKazooNumbersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetKazooNumbersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getKazooNumbers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
