// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new endpoint API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for endpoint API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetEndpoints(params *GetEndpointsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetEndpointsOK, error)

	PostEndpoints(params *PostEndpointsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostEndpointsOK, error)

	PutEndpoints(params *PutEndpointsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutEndpointsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetEndpoints gets a list of endpoints

  Return a list of available Endpoint entities
*/
func (a *Client) GetEndpoints(params *GetEndpointsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetEndpointsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetEndpointsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getEndpoints",
		Method:             "GET",
		PathPattern:        "/endpoints",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetEndpointsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetEndpointsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getEndpoints: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostEndpoints adds new endpoints

  Create new Endpoints
*/
func (a *Client) PostEndpoints(params *PostEndpointsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostEndpointsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostEndpointsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postEndpoints",
		Method:             "POST",
		PathPattern:        "/endpoints",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostEndpointsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostEndpointsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postEndpoints: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutEndpoints updates endpoints

  Update fields in Endpoint records identified by Telnexus Id
*/
func (a *Client) PutEndpoints(params *PutEndpointsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutEndpointsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutEndpointsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putEndpoints",
		Method:             "PUT",
		PathPattern:        "/endpoints",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutEndpointsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutEndpointsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putEndpoints: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
