// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/voip/voip_models"
)

// NewPutEndpointsParams creates a new PutEndpointsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutEndpointsParams() *PutEndpointsParams {
	return &PutEndpointsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutEndpointsParamsWithTimeout creates a new PutEndpointsParams object
// with the ability to set a timeout on a request.
func NewPutEndpointsParamsWithTimeout(timeout time.Duration) *PutEndpointsParams {
	return &PutEndpointsParams{
		timeout: timeout,
	}
}

// NewPutEndpointsParamsWithContext creates a new PutEndpointsParams object
// with the ability to set a context for a request.
func NewPutEndpointsParamsWithContext(ctx context.Context) *PutEndpointsParams {
	return &PutEndpointsParams{
		Context: ctx,
	}
}

// NewPutEndpointsParamsWithHTTPClient creates a new PutEndpointsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutEndpointsParamsWithHTTPClient(client *http.Client) *PutEndpointsParams {
	return &PutEndpointsParams{
		HTTPClient: client,
	}
}

/* PutEndpointsParams contains all the parameters to send to the API endpoint
   for the put endpoints operation.

   Typically these are written to a http.Request.
*/
type PutEndpointsParams struct {

	/* EndpointRequest.

	   An array of new PBX records
	*/
	EndpointRequest *voip_models.EndpointRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put endpoints params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutEndpointsParams) WithDefaults() *PutEndpointsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put endpoints params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutEndpointsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put endpoints params
func (o *PutEndpointsParams) WithTimeout(timeout time.Duration) *PutEndpointsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put endpoints params
func (o *PutEndpointsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put endpoints params
func (o *PutEndpointsParams) WithContext(ctx context.Context) *PutEndpointsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put endpoints params
func (o *PutEndpointsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put endpoints params
func (o *PutEndpointsParams) WithHTTPClient(client *http.Client) *PutEndpointsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put endpoints params
func (o *PutEndpointsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEndpointRequest adds the endpointRequest to the put endpoints params
func (o *PutEndpointsParams) WithEndpointRequest(endpointRequest *voip_models.EndpointRequest) *PutEndpointsParams {
	o.SetEndpointRequest(endpointRequest)
	return o
}

// SetEndpointRequest adds the endpointRequest to the put endpoints params
func (o *PutEndpointsParams) SetEndpointRequest(endpointRequest *voip_models.EndpointRequest) {
	o.EndpointRequest = endpointRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutEndpointsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.EndpointRequest != nil {
		if err := r.SetBodyParam(o.EndpointRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
