// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPBXesParams creates a new GetPBXesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetPBXesParams() *GetPBXesParams {
	return &GetPBXesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetPBXesParamsWithTimeout creates a new GetPBXesParams object
// with the ability to set a timeout on a request.
func NewGetPBXesParamsWithTimeout(timeout time.Duration) *GetPBXesParams {
	return &GetPBXesParams{
		timeout: timeout,
	}
}

// NewGetPBXesParamsWithContext creates a new GetPBXesParams object
// with the ability to set a context for a request.
func NewGetPBXesParamsWithContext(ctx context.Context) *GetPBXesParams {
	return &GetPBXesParams{
		Context: ctx,
	}
}

// NewGetPBXesParamsWithHTTPClient creates a new GetPBXesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetPBXesParamsWithHTTPClient(client *http.Client) *GetPBXesParams {
	return &GetPBXesParams{
		HTTPClient: client,
	}
}

/* GetPBXesParams contains all the parameters to send to the API endpoint
   for the get p b xes operation.

   Typically these are written to a http.Request.
*/
type GetPBXesParams struct {

	/* Limit.

	   How many objects to return at one time (max 300, default 100)

	   Format: int64
	   Default: 100
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* PbxID.

	   Telnexus Id of the PBX to be retrieved
	*/
	PbxID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get p b xes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPBXesParams) WithDefaults() *GetPBXesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get p b xes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPBXesParams) SetDefaults() {
	var (
		limitDefault = int64(100)

		offsetDefault = int64(0)
	)

	val := GetPBXesParams{
		Limit:  &limitDefault,
		Offset: &offsetDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get p b xes params
func (o *GetPBXesParams) WithTimeout(timeout time.Duration) *GetPBXesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get p b xes params
func (o *GetPBXesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get p b xes params
func (o *GetPBXesParams) WithContext(ctx context.Context) *GetPBXesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get p b xes params
func (o *GetPBXesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get p b xes params
func (o *GetPBXesParams) WithHTTPClient(client *http.Client) *GetPBXesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get p b xes params
func (o *GetPBXesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get p b xes params
func (o *GetPBXesParams) WithLimit(limit *int64) *GetPBXesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get p b xes params
func (o *GetPBXesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get p b xes params
func (o *GetPBXesParams) WithOffset(offset *int64) *GetPBXesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get p b xes params
func (o *GetPBXesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPbxID adds the pbxID to the get p b xes params
func (o *GetPBXesParams) WithPbxID(pbxID *string) *GetPBXesParams {
	o.SetPbxID(pbxID)
	return o
}

// SetPbxID adds the pbxId to the get p b xes params
func (o *GetPBXesParams) SetPbxID(pbxID *string) {
	o.PbxID = pbxID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPBXesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.PbxID != nil {

		// query param pbxId
		var qrPbxID string

		if o.PbxID != nil {
			qrPbxID = *o.PbxID
		}
		qPbxID := qrPbxID
		if qPbxID != "" {

			if err := r.SetQueryParam("pbxId", qPbxID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
