// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/voip/voip_models"
)

// GetPBXesReader is a Reader for the GetPBXes structure.
type GetPBXesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPBXesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPBXesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetPBXesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetPBXesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetPBXesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetPBXesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetPBXesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetPBXesOK creates a GetPBXesOK with default headers values
func NewGetPBXesOK() *GetPBXesOK {
	return &GetPBXesOK{}
}

/* GetPBXesOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type GetPBXesOK struct {
	Payload *voip_models.PbxResponse
}

func (o *GetPBXesOK) Error() string {
	return fmt.Sprintf("[GET /pbxes][%d] getPBXesOK  %+v", 200, o.Payload)
}
func (o *GetPBXesOK) GetPayload() *voip_models.PbxResponse {
	return o.Payload
}

func (o *GetPBXesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PbxResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXesUnauthorized creates a GetPBXesUnauthorized with default headers values
func NewGetPBXesUnauthorized() *GetPBXesUnauthorized {
	return &GetPBXesUnauthorized{}
}

/* GetPBXesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetPBXesUnauthorized struct {
	Payload *voip_models.Error
}

func (o *GetPBXesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /pbxes][%d] getPBXesUnauthorized  %+v", 401, o.Payload)
}
func (o *GetPBXesUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXesForbidden creates a GetPBXesForbidden with default headers values
func NewGetPBXesForbidden() *GetPBXesForbidden {
	return &GetPBXesForbidden{}
}

/* GetPBXesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetPBXesForbidden struct {
	Payload *voip_models.Error
}

func (o *GetPBXesForbidden) Error() string {
	return fmt.Sprintf("[GET /pbxes][%d] getPBXesForbidden  %+v", 403, o.Payload)
}
func (o *GetPBXesForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXesNotFound creates a GetPBXesNotFound with default headers values
func NewGetPBXesNotFound() *GetPBXesNotFound {
	return &GetPBXesNotFound{}
}

/* GetPBXesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetPBXesNotFound struct {
	Payload *voip_models.Error
}

func (o *GetPBXesNotFound) Error() string {
	return fmt.Sprintf("[GET /pbxes][%d] getPBXesNotFound  %+v", 404, o.Payload)
}
func (o *GetPBXesNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXesUnprocessableEntity creates a GetPBXesUnprocessableEntity with default headers values
func NewGetPBXesUnprocessableEntity() *GetPBXesUnprocessableEntity {
	return &GetPBXesUnprocessableEntity{}
}

/* GetPBXesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetPBXesUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *GetPBXesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /pbxes][%d] getPBXesUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetPBXesUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXesInternalServerError creates a GetPBXesInternalServerError with default headers values
func NewGetPBXesInternalServerError() *GetPBXesInternalServerError {
	return &GetPBXesInternalServerError{}
}

/* GetPBXesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetPBXesInternalServerError struct {
	Payload *voip_models.Error
}

func (o *GetPBXesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /pbxes][%d] getPBXesInternalServerError  %+v", 500, o.Payload)
}
func (o *GetPBXesInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
