// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx_user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPBXUsersParams creates a new GetPBXUsersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetPBXUsersParams() *GetPBXUsersParams {
	return &GetPBXUsersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetPBXUsersParamsWithTimeout creates a new GetPBXUsersParams object
// with the ability to set a timeout on a request.
func NewGetPBXUsersParamsWithTimeout(timeout time.Duration) *GetPBXUsersParams {
	return &GetPBXUsersParams{
		timeout: timeout,
	}
}

// NewGetPBXUsersParamsWithContext creates a new GetPBXUsersParams object
// with the ability to set a context for a request.
func NewGetPBXUsersParamsWithContext(ctx context.Context) *GetPBXUsersParams {
	return &GetPBXUsersParams{
		Context: ctx,
	}
}

// NewGetPBXUsersParamsWithHTTPClient creates a new GetPBXUsersParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetPBXUsersParamsWithHTTPClient(client *http.Client) *GetPBXUsersParams {
	return &GetPBXUsersParams{
		HTTPClient: client,
	}
}

/* GetPBXUsersParams contains all the parameters to send to the API endpoint
   for the get p b x users operation.

   Typically these are written to a http.Request.
*/
type GetPBXUsersParams struct {

	/* Limit.

	   How many objects to return at one time (max 300, default 100)

	   Format: int64
	   Default: 100
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* PbxUserID.

	   Telnexus Id of the PBX User to be retrieved
	*/
	PbxUserID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get p b x users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPBXUsersParams) WithDefaults() *GetPBXUsersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get p b x users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPBXUsersParams) SetDefaults() {
	var (
		limitDefault = int64(100)

		offsetDefault = int64(0)
	)

	val := GetPBXUsersParams{
		Limit:  &limitDefault,
		Offset: &offsetDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get p b x users params
func (o *GetPBXUsersParams) WithTimeout(timeout time.Duration) *GetPBXUsersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get p b x users params
func (o *GetPBXUsersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get p b x users params
func (o *GetPBXUsersParams) WithContext(ctx context.Context) *GetPBXUsersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get p b x users params
func (o *GetPBXUsersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get p b x users params
func (o *GetPBXUsersParams) WithHTTPClient(client *http.Client) *GetPBXUsersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get p b x users params
func (o *GetPBXUsersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get p b x users params
func (o *GetPBXUsersParams) WithLimit(limit *int64) *GetPBXUsersParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get p b x users params
func (o *GetPBXUsersParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get p b x users params
func (o *GetPBXUsersParams) WithOffset(offset *int64) *GetPBXUsersParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get p b x users params
func (o *GetPBXUsersParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPbxUserID adds the pbxUserID to the get p b x users params
func (o *GetPBXUsersParams) WithPbxUserID(pbxUserID *string) *GetPBXUsersParams {
	o.SetPbxUserID(pbxUserID)
	return o
}

// SetPbxUserID adds the pbxUserId to the get p b x users params
func (o *GetPBXUsersParams) SetPbxUserID(pbxUserID *string) {
	o.PbxUserID = pbxUserID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPBXUsersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.PbxUserID != nil {

		// query param pbxUserId
		var qrPbxUserID string

		if o.PbxUserID != nil {
			qrPbxUserID = *o.PbxUserID
		}
		qPbxUserID := qrPbxUserID
		if qPbxUserID != "" {

			if err := r.SetQueryParam("pbxUserId", qPbxUserID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
