// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx_user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new pbx user API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for pbx user API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	PBXUsers(params *PBXUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PBXUsersOK, error)

	GetPBXUsers(params *GetPBXUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetPBXUsersOK, error)

	PostPBXUsers(params *PostPBXUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostPBXUsersOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  PBXUsers updates p b x users

  Update fields in PBXUsers record identified by Telnexus Id
*/
func (a *Client) PBXUsers(params *PBXUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PBXUsersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPBXUsersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "PBXUsers",
		Method:             "PUT",
		PathPattern:        "/pbxusers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PBXUsersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PBXUsersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for PBXUsers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetPBXUsers gets a list of authorities

  Return a list of available PBX Users
*/
func (a *Client) GetPBXUsers(params *GetPBXUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetPBXUsersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPBXUsersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getPBXUsers",
		Method:             "GET",
		PathPattern:        "/pbxusers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPBXUsersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPBXUsersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPBXUsers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPBXUsers adds new p b x users

  Create new PBXUsers
*/
func (a *Client) PostPBXUsers(params *PostPBXUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostPBXUsersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPBXUsersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postPBXUsers",
		Method:             "POST",
		PathPattern:        "/pbxusers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPBXUsersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPBXUsersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPBXUsers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
