// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package phone_number

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/voip/voip_models"
)

// GetPhoneNumbersReader is a Reader for the GetPhoneNumbers structure.
type GetPhoneNumbersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPhoneNumbersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPhoneNumbersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetPhoneNumbersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetPhoneNumbersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetPhoneNumbersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetPhoneNumbersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetPhoneNumbersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetPhoneNumbersOK creates a GetPhoneNumbersOK with default headers values
func NewGetPhoneNumbersOK() *GetPhoneNumbersOK {
	return &GetPhoneNumbersOK{}
}

/* GetPhoneNumbersOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type GetPhoneNumbersOK struct {
	Payload *voip_models.PhoneNumberResponse
}

func (o *GetPhoneNumbersOK) Error() string {
	return fmt.Sprintf("[GET /phonenumbers][%d] getPhoneNumbersOK  %+v", 200, o.Payload)
}
func (o *GetPhoneNumbersOK) GetPayload() *voip_models.PhoneNumberResponse {
	return o.Payload
}

func (o *GetPhoneNumbersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PhoneNumberResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPhoneNumbersUnauthorized creates a GetPhoneNumbersUnauthorized with default headers values
func NewGetPhoneNumbersUnauthorized() *GetPhoneNumbersUnauthorized {
	return &GetPhoneNumbersUnauthorized{}
}

/* GetPhoneNumbersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetPhoneNumbersUnauthorized struct {
	Payload *voip_models.Error
}

func (o *GetPhoneNumbersUnauthorized) Error() string {
	return fmt.Sprintf("[GET /phonenumbers][%d] getPhoneNumbersUnauthorized  %+v", 401, o.Payload)
}
func (o *GetPhoneNumbersUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPhoneNumbersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPhoneNumbersForbidden creates a GetPhoneNumbersForbidden with default headers values
func NewGetPhoneNumbersForbidden() *GetPhoneNumbersForbidden {
	return &GetPhoneNumbersForbidden{}
}

/* GetPhoneNumbersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetPhoneNumbersForbidden struct {
	Payload *voip_models.Error
}

func (o *GetPhoneNumbersForbidden) Error() string {
	return fmt.Sprintf("[GET /phonenumbers][%d] getPhoneNumbersForbidden  %+v", 403, o.Payload)
}
func (o *GetPhoneNumbersForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPhoneNumbersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPhoneNumbersNotFound creates a GetPhoneNumbersNotFound with default headers values
func NewGetPhoneNumbersNotFound() *GetPhoneNumbersNotFound {
	return &GetPhoneNumbersNotFound{}
}

/* GetPhoneNumbersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetPhoneNumbersNotFound struct {
	Payload *voip_models.Error
}

func (o *GetPhoneNumbersNotFound) Error() string {
	return fmt.Sprintf("[GET /phonenumbers][%d] getPhoneNumbersNotFound  %+v", 404, o.Payload)
}
func (o *GetPhoneNumbersNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPhoneNumbersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPhoneNumbersUnprocessableEntity creates a GetPhoneNumbersUnprocessableEntity with default headers values
func NewGetPhoneNumbersUnprocessableEntity() *GetPhoneNumbersUnprocessableEntity {
	return &GetPhoneNumbersUnprocessableEntity{}
}

/* GetPhoneNumbersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetPhoneNumbersUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *GetPhoneNumbersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /phonenumbers][%d] getPhoneNumbersUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetPhoneNumbersUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPhoneNumbersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPhoneNumbersInternalServerError creates a GetPhoneNumbersInternalServerError with default headers values
func NewGetPhoneNumbersInternalServerError() *GetPhoneNumbersInternalServerError {
	return &GetPhoneNumbersInternalServerError{}
}

/* GetPhoneNumbersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetPhoneNumbersInternalServerError struct {
	Payload *voip_models.Error
}

func (o *GetPhoneNumbersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /phonenumbers][%d] getPhoneNumbersInternalServerError  %+v", 500, o.Payload)
}
func (o *GetPhoneNumbersInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPhoneNumbersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
