// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package phone_number

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new phone number API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for phone number API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetPhoneNumbers(params *GetPhoneNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetPhoneNumbersOK, error)

	PostPhoneNumbers(params *PostPhoneNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostPhoneNumbersOK, error)

	PutPhoneNumbers(params *PutPhoneNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutPhoneNumbersOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetPhoneNumbers gets a list of phone number

  Return a list of available Phone Number entities
*/
func (a *Client) GetPhoneNumbers(params *GetPhoneNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetPhoneNumbersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPhoneNumbersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getPhoneNumbers",
		Method:             "GET",
		PathPattern:        "/phonenumbers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPhoneNumbersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPhoneNumbersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPhoneNumbers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPhoneNumbers adds new phone numbers

  Create new Phone Numbers
*/
func (a *Client) PostPhoneNumbers(params *PostPhoneNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostPhoneNumbersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPhoneNumbersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postPhoneNumbers",
		Method:             "POST",
		PathPattern:        "/phonenumbers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPhoneNumbersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPhoneNumbersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPhoneNumbers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutPhoneNumbers updates phone numbers

  Update fields in an Phone Number record identified by Telnexus Id
*/
func (a *Client) PutPhoneNumbers(params *PutPhoneNumbersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutPhoneNumbersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutPhoneNumbersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putPhoneNumbers",
		Method:             "PUT",
		PathPattern:        "/phonenumbers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutPhoneNumbersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutPhoneNumbersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putPhoneNumbers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
