// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package phone_number

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/voip/voip_models"
)

// PostPhoneNumbersReader is a Reader for the PostPhoneNumbers structure.
type PostPhoneNumbersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostPhoneNumbersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostPhoneNumbersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostPhoneNumbersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostPhoneNumbersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostPhoneNumbersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostPhoneNumbersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostPhoneNumbersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostPhoneNumbersOK creates a PostPhoneNumbersOK with default headers values
func NewPostPhoneNumbersOK() *PostPhoneNumbersOK {
	return &PostPhoneNumbersOK{}
}

/* PostPhoneNumbersOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type PostPhoneNumbersOK struct {
	Payload *voip_models.PhoneNumberResponse
}

func (o *PostPhoneNumbersOK) Error() string {
	return fmt.Sprintf("[POST /phonenumbers][%d] postPhoneNumbersOK  %+v", 200, o.Payload)
}
func (o *PostPhoneNumbersOK) GetPayload() *voip_models.PhoneNumberResponse {
	return o.Payload
}

func (o *PostPhoneNumbersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PhoneNumberResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPhoneNumbersUnauthorized creates a PostPhoneNumbersUnauthorized with default headers values
func NewPostPhoneNumbersUnauthorized() *PostPhoneNumbersUnauthorized {
	return &PostPhoneNumbersUnauthorized{}
}

/* PostPhoneNumbersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostPhoneNumbersUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PostPhoneNumbersUnauthorized) Error() string {
	return fmt.Sprintf("[POST /phonenumbers][%d] postPhoneNumbersUnauthorized  %+v", 401, o.Payload)
}
func (o *PostPhoneNumbersUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPhoneNumbersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPhoneNumbersForbidden creates a PostPhoneNumbersForbidden with default headers values
func NewPostPhoneNumbersForbidden() *PostPhoneNumbersForbidden {
	return &PostPhoneNumbersForbidden{}
}

/* PostPhoneNumbersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostPhoneNumbersForbidden struct {
	Payload *voip_models.Error
}

func (o *PostPhoneNumbersForbidden) Error() string {
	return fmt.Sprintf("[POST /phonenumbers][%d] postPhoneNumbersForbidden  %+v", 403, o.Payload)
}
func (o *PostPhoneNumbersForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPhoneNumbersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPhoneNumbersNotFound creates a PostPhoneNumbersNotFound with default headers values
func NewPostPhoneNumbersNotFound() *PostPhoneNumbersNotFound {
	return &PostPhoneNumbersNotFound{}
}

/* PostPhoneNumbersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostPhoneNumbersNotFound struct {
	Payload *voip_models.Error
}

func (o *PostPhoneNumbersNotFound) Error() string {
	return fmt.Sprintf("[POST /phonenumbers][%d] postPhoneNumbersNotFound  %+v", 404, o.Payload)
}
func (o *PostPhoneNumbersNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPhoneNumbersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPhoneNumbersUnprocessableEntity creates a PostPhoneNumbersUnprocessableEntity with default headers values
func NewPostPhoneNumbersUnprocessableEntity() *PostPhoneNumbersUnprocessableEntity {
	return &PostPhoneNumbersUnprocessableEntity{}
}

/* PostPhoneNumbersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostPhoneNumbersUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PostPhoneNumbersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /phonenumbers][%d] postPhoneNumbersUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostPhoneNumbersUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPhoneNumbersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPhoneNumbersInternalServerError creates a PostPhoneNumbersInternalServerError with default headers values
func NewPostPhoneNumbersInternalServerError() *PostPhoneNumbersInternalServerError {
	return &PostPhoneNumbersInternalServerError{}
}

/* PostPhoneNumbersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostPhoneNumbersInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PostPhoneNumbersInternalServerError) Error() string {
	return fmt.Sprintf("[POST /phonenumbers][%d] postPhoneNumbersInternalServerError  %+v", 500, o.Payload)
}
func (o *PostPhoneNumbersInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPhoneNumbersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
