// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package queue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetQueuesParams creates a new GetQueuesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetQueuesParams() *GetQueuesParams {
	return &GetQueuesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetQueuesParamsWithTimeout creates a new GetQueuesParams object
// with the ability to set a timeout on a request.
func NewGetQueuesParamsWithTimeout(timeout time.Duration) *GetQueuesParams {
	return &GetQueuesParams{
		timeout: timeout,
	}
}

// NewGetQueuesParamsWithContext creates a new GetQueuesParams object
// with the ability to set a context for a request.
func NewGetQueuesParamsWithContext(ctx context.Context) *GetQueuesParams {
	return &GetQueuesParams{
		Context: ctx,
	}
}

// NewGetQueuesParamsWithHTTPClient creates a new GetQueuesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetQueuesParamsWithHTTPClient(client *http.Client) *GetQueuesParams {
	return &GetQueuesParams{
		HTTPClient: client,
	}
}

/* GetQueuesParams contains all the parameters to send to the API endpoint
   for the get queues operation.

   Typically these are written to a http.Request.
*/
type GetQueuesParams struct {

	/* Limit.

	   How many objects to return at one time (max 300, default 100)

	   Format: int64
	   Default: 100
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* QueueID.

	   Telnexus Id of the Queue to be retrieved
	*/
	QueueID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get queues params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetQueuesParams) WithDefaults() *GetQueuesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get queues params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetQueuesParams) SetDefaults() {
	var (
		limitDefault = int64(100)

		offsetDefault = int64(0)
	)

	val := GetQueuesParams{
		Limit:  &limitDefault,
		Offset: &offsetDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get queues params
func (o *GetQueuesParams) WithTimeout(timeout time.Duration) *GetQueuesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get queues params
func (o *GetQueuesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get queues params
func (o *GetQueuesParams) WithContext(ctx context.Context) *GetQueuesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get queues params
func (o *GetQueuesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get queues params
func (o *GetQueuesParams) WithHTTPClient(client *http.Client) *GetQueuesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get queues params
func (o *GetQueuesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get queues params
func (o *GetQueuesParams) WithLimit(limit *int64) *GetQueuesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get queues params
func (o *GetQueuesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get queues params
func (o *GetQueuesParams) WithOffset(offset *int64) *GetQueuesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get queues params
func (o *GetQueuesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQueueID adds the queueID to the get queues params
func (o *GetQueuesParams) WithQueueID(queueID *string) *GetQueuesParams {
	o.SetQueueID(queueID)
	return o
}

// SetQueueID adds the queueId to the get queues params
func (o *GetQueuesParams) SetQueueID(queueID *string) {
	o.QueueID = queueID
}

// WriteToRequest writes these params to a swagger request
func (o *GetQueuesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.QueueID != nil {

		// query param queueId
		var qrQueueID string

		if o.QueueID != nil {
			qrQueueID = *o.QueueID
		}
		qQueueID := qrQueueID
		if qQueueID != "" {

			if err := r.SetQueryParam("queueId", qQueueID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
