// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package queue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/voip/voip_models"
)

// NewPostQueuesParams creates a new PostQueuesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostQueuesParams() *PostQueuesParams {
	return &PostQueuesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostQueuesParamsWithTimeout creates a new PostQueuesParams object
// with the ability to set a timeout on a request.
func NewPostQueuesParamsWithTimeout(timeout time.Duration) *PostQueuesParams {
	return &PostQueuesParams{
		timeout: timeout,
	}
}

// NewPostQueuesParamsWithContext creates a new PostQueuesParams object
// with the ability to set a context for a request.
func NewPostQueuesParamsWithContext(ctx context.Context) *PostQueuesParams {
	return &PostQueuesParams{
		Context: ctx,
	}
}

// NewPostQueuesParamsWithHTTPClient creates a new PostQueuesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostQueuesParamsWithHTTPClient(client *http.Client) *PostQueuesParams {
	return &PostQueuesParams{
		HTTPClient: client,
	}
}

/* PostQueuesParams contains all the parameters to send to the API endpoint
   for the post queues operation.

   Typically these are written to a http.Request.
*/
type PostQueuesParams struct {

	/* QueueRequest.

	   An array of new Queues
	*/
	QueueRequest *voip_models.QueueRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post queues params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostQueuesParams) WithDefaults() *PostQueuesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post queues params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostQueuesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post queues params
func (o *PostQueuesParams) WithTimeout(timeout time.Duration) *PostQueuesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post queues params
func (o *PostQueuesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post queues params
func (o *PostQueuesParams) WithContext(ctx context.Context) *PostQueuesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post queues params
func (o *PostQueuesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post queues params
func (o *PostQueuesParams) WithHTTPClient(client *http.Client) *PostQueuesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post queues params
func (o *PostQueuesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithQueueRequest adds the queueRequest to the post queues params
func (o *PostQueuesParams) WithQueueRequest(queueRequest *voip_models.QueueRequest) *PostQueuesParams {
	o.SetQueueRequest(queueRequest)
	return o
}

// SetQueueRequest adds the queueRequest to the post queues params
func (o *PostQueuesParams) SetQueueRequest(queueRequest *voip_models.QueueRequest) {
	o.QueueRequest = queueRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostQueuesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.QueueRequest != nil {
		if err := r.SetBodyParam(o.QueueRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
