// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package vm_box

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetVMBoxesParams creates a new GetVMBoxesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetVMBoxesParams() *GetVMBoxesParams {
	return &GetVMBoxesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetVMBoxesParamsWithTimeout creates a new GetVMBoxesParams object
// with the ability to set a timeout on a request.
func NewGetVMBoxesParamsWithTimeout(timeout time.Duration) *GetVMBoxesParams {
	return &GetVMBoxesParams{
		timeout: timeout,
	}
}

// NewGetVMBoxesParamsWithContext creates a new GetVMBoxesParams object
// with the ability to set a context for a request.
func NewGetVMBoxesParamsWithContext(ctx context.Context) *GetVMBoxesParams {
	return &GetVMBoxesParams{
		Context: ctx,
	}
}

// NewGetVMBoxesParamsWithHTTPClient creates a new GetVMBoxesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetVMBoxesParamsWithHTTPClient(client *http.Client) *GetVMBoxesParams {
	return &GetVMBoxesParams{
		HTTPClient: client,
	}
}

/* GetVMBoxesParams contains all the parameters to send to the API endpoint
   for the get Vm boxes operation.

   Typically these are written to a http.Request.
*/
type GetVMBoxesParams struct {

	/* Limit.

	   How many objects to return at one time (max 300, default 100)

	   Format: int64
	   Default: 100
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* VMBoxID.

	   Telnexus Id of the vmBox to be retrieved
	*/
	VMBoxID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get Vm boxes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetVMBoxesParams) WithDefaults() *GetVMBoxesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get Vm boxes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetVMBoxesParams) SetDefaults() {
	var (
		limitDefault = int64(100)

		offsetDefault = int64(0)
	)

	val := GetVMBoxesParams{
		Limit:  &limitDefault,
		Offset: &offsetDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get Vm boxes params
func (o *GetVMBoxesParams) WithTimeout(timeout time.Duration) *GetVMBoxesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get Vm boxes params
func (o *GetVMBoxesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get Vm boxes params
func (o *GetVMBoxesParams) WithContext(ctx context.Context) *GetVMBoxesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get Vm boxes params
func (o *GetVMBoxesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get Vm boxes params
func (o *GetVMBoxesParams) WithHTTPClient(client *http.Client) *GetVMBoxesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get Vm boxes params
func (o *GetVMBoxesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get Vm boxes params
func (o *GetVMBoxesParams) WithLimit(limit *int64) *GetVMBoxesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get Vm boxes params
func (o *GetVMBoxesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get Vm boxes params
func (o *GetVMBoxesParams) WithOffset(offset *int64) *GetVMBoxesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get Vm boxes params
func (o *GetVMBoxesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithVMBoxID adds the vMBoxID to the get Vm boxes params
func (o *GetVMBoxesParams) WithVMBoxID(vMBoxID *string) *GetVMBoxesParams {
	o.SetVMBoxID(vMBoxID)
	return o
}

// SetVMBoxID adds the vmBoxId to the get Vm boxes params
func (o *GetVMBoxesParams) SetVMBoxID(vMBoxID *string) {
	o.VMBoxID = vMBoxID
}

// WriteToRequest writes these params to a swagger request
func (o *GetVMBoxesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.VMBoxID != nil {

		// query param vmBoxId
		var qrVMBoxID string

		if o.VMBoxID != nil {
			qrVMBoxID = *o.VMBoxID
		}
		qVMBoxID := qrVMBoxID
		if qVMBoxID != "" {

			if err := r.SetQueryParam("vmBoxId", qVMBoxID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
