// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package vm_box

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/voip/voip_models"
)

// PostVMBoxesReader is a Reader for the PostVMBoxes structure.
type PostVMBoxesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostVMBoxesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostVMBoxesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostVMBoxesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostVMBoxesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostVMBoxesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostVMBoxesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostVMBoxesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostVMBoxesOK creates a PostVMBoxesOK with default headers values
func NewPostVMBoxesOK() *PostVMBoxesOK {
	return &PostVMBoxesOK{}
}

/* PostVMBoxesOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type PostVMBoxesOK struct {
	Payload *voip_models.VMBoxResponse
}

func (o *PostVMBoxesOK) Error() string {
	return fmt.Sprintf("[POST /vmboxes][%d] postVmBoxesOK  %+v", 200, o.Payload)
}
func (o *PostVMBoxesOK) GetPayload() *voip_models.VMBoxResponse {
	return o.Payload
}

func (o *PostVMBoxesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.VMBoxResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostVMBoxesUnauthorized creates a PostVMBoxesUnauthorized with default headers values
func NewPostVMBoxesUnauthorized() *PostVMBoxesUnauthorized {
	return &PostVMBoxesUnauthorized{}
}

/* PostVMBoxesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostVMBoxesUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PostVMBoxesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /vmboxes][%d] postVmBoxesUnauthorized  %+v", 401, o.Payload)
}
func (o *PostVMBoxesUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostVMBoxesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostVMBoxesForbidden creates a PostVMBoxesForbidden with default headers values
func NewPostVMBoxesForbidden() *PostVMBoxesForbidden {
	return &PostVMBoxesForbidden{}
}

/* PostVMBoxesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostVMBoxesForbidden struct {
	Payload *voip_models.Error
}

func (o *PostVMBoxesForbidden) Error() string {
	return fmt.Sprintf("[POST /vmboxes][%d] postVmBoxesForbidden  %+v", 403, o.Payload)
}
func (o *PostVMBoxesForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostVMBoxesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostVMBoxesNotFound creates a PostVMBoxesNotFound with default headers values
func NewPostVMBoxesNotFound() *PostVMBoxesNotFound {
	return &PostVMBoxesNotFound{}
}

/* PostVMBoxesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostVMBoxesNotFound struct {
	Payload *voip_models.Error
}

func (o *PostVMBoxesNotFound) Error() string {
	return fmt.Sprintf("[POST /vmboxes][%d] postVmBoxesNotFound  %+v", 404, o.Payload)
}
func (o *PostVMBoxesNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostVMBoxesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostVMBoxesUnprocessableEntity creates a PostVMBoxesUnprocessableEntity with default headers values
func NewPostVMBoxesUnprocessableEntity() *PostVMBoxesUnprocessableEntity {
	return &PostVMBoxesUnprocessableEntity{}
}

/* PostVMBoxesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostVMBoxesUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PostVMBoxesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /vmboxes][%d] postVmBoxesUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostVMBoxesUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostVMBoxesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostVMBoxesInternalServerError creates a PostVMBoxesInternalServerError with default headers values
func NewPostVMBoxesInternalServerError() *PostVMBoxesInternalServerError {
	return &PostVMBoxesInternalServerError{}
}

/* PostVMBoxesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostVMBoxesInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PostVMBoxesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /vmboxes][%d] postVmBoxesInternalServerError  %+v", 500, o.Payload)
}
func (o *PostVMBoxesInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostVMBoxesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
