// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package vm_box

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/voip/voip_models"
)

// PutVMBoxesReader is a Reader for the PutVMBoxes structure.
type PutVMBoxesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutVMBoxesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutVMBoxesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutVMBoxesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutVMBoxesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutVMBoxesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutVMBoxesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutVMBoxesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutVMBoxesOK creates a PutVMBoxesOK with default headers values
func NewPutVMBoxesOK() *PutVMBoxesOK {
	return &PutVMBoxesOK{}
}

/* PutVMBoxesOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type PutVMBoxesOK struct {
	Payload *voip_models.VMBoxResponse
}

func (o *PutVMBoxesOK) Error() string {
	return fmt.Sprintf("[PUT /vmboxes][%d] putVmBoxesOK  %+v", 200, o.Payload)
}
func (o *PutVMBoxesOK) GetPayload() *voip_models.VMBoxResponse {
	return o.Payload
}

func (o *PutVMBoxesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.VMBoxResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutVMBoxesUnauthorized creates a PutVMBoxesUnauthorized with default headers values
func NewPutVMBoxesUnauthorized() *PutVMBoxesUnauthorized {
	return &PutVMBoxesUnauthorized{}
}

/* PutVMBoxesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutVMBoxesUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PutVMBoxesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /vmboxes][%d] putVmBoxesUnauthorized  %+v", 401, o.Payload)
}
func (o *PutVMBoxesUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutVMBoxesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutVMBoxesForbidden creates a PutVMBoxesForbidden with default headers values
func NewPutVMBoxesForbidden() *PutVMBoxesForbidden {
	return &PutVMBoxesForbidden{}
}

/* PutVMBoxesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutVMBoxesForbidden struct {
	Payload *voip_models.Error
}

func (o *PutVMBoxesForbidden) Error() string {
	return fmt.Sprintf("[PUT /vmboxes][%d] putVmBoxesForbidden  %+v", 403, o.Payload)
}
func (o *PutVMBoxesForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutVMBoxesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutVMBoxesNotFound creates a PutVMBoxesNotFound with default headers values
func NewPutVMBoxesNotFound() *PutVMBoxesNotFound {
	return &PutVMBoxesNotFound{}
}

/* PutVMBoxesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutVMBoxesNotFound struct {
	Payload *voip_models.Error
}

func (o *PutVMBoxesNotFound) Error() string {
	return fmt.Sprintf("[PUT /vmboxes][%d] putVmBoxesNotFound  %+v", 404, o.Payload)
}
func (o *PutVMBoxesNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutVMBoxesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutVMBoxesUnprocessableEntity creates a PutVMBoxesUnprocessableEntity with default headers values
func NewPutVMBoxesUnprocessableEntity() *PutVMBoxesUnprocessableEntity {
	return &PutVMBoxesUnprocessableEntity{}
}

/* PutVMBoxesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutVMBoxesUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PutVMBoxesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /vmboxes][%d] putVmBoxesUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutVMBoxesUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutVMBoxesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutVMBoxesInternalServerError creates a PutVMBoxesInternalServerError with default headers values
func NewPutVMBoxesInternalServerError() *PutVMBoxesInternalServerError {
	return &PutVMBoxesInternalServerError{}
}

/* PutVMBoxesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutVMBoxesInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PutVMBoxesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /vmboxes][%d] putVmBoxesInternalServerError  %+v", 500, o.Payload)
}
func (o *PutVMBoxesInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutVMBoxesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
