// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package vm_box

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new vm box API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for vm box API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetVMBoxes(params *GetVMBoxesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetVMBoxesOK, error)

	PostVMBoxes(params *PostVMBoxesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostVMBoxesOK, error)

	PutVMBoxes(params *PutVMBoxesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutVMBoxesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetVMBoxes gets a list of voice mail boxes

  Return a list of available Voice Mail Box entities
*/
func (a *Client) GetVMBoxes(params *GetVMBoxesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetVMBoxesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetVMBoxesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getVmBoxes",
		Method:             "GET",
		PathPattern:        "/vmboxes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetVMBoxesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetVMBoxesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getVmBoxes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostVMBoxes adds new voice mail boxes

  Create new VmBoxes
*/
func (a *Client) PostVMBoxes(params *PostVMBoxesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostVMBoxesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostVMBoxesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postVmBoxes",
		Method:             "POST",
		PathPattern:        "/vmboxes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostVMBoxesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostVMBoxesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postVmBoxes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutVMBoxes updates voice mail boxes

  Update fields in Voice Mail Box records identified by Telnexus Id
*/
func (a *Client) PutVMBoxes(params *PutVMBoxesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutVMBoxesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutVMBoxesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putVmBoxes",
		Method:             "PUT",
		PathPattern:        "/vmboxes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutVMBoxesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutVMBoxesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putVmBoxes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
